#ifndef STREU_CPLUSLIB_ENUM_H_INCLUDED
#define STREU_CPLUSLIB_ENUM_H_INCLUDED

/* #ifndef STREU_CPLUS_LIB */
/* #  include "cpluslib/config.h" */
/* #endif */

/** Enumeration. A generalized form of an input iterator, differing
    from the STL iterator mainly in the fact that this one explicitly
    provides late binding. */
template<class T>
class Enumeration {
 public:
    virtual ~Enumeration() { }

    /** Check for Elements.
        \return true iff there are more elements in this enumeration */
    virtual bool hasMoreElements() = 0;

    /** Get next element.
        \return the element
        \pre hasMoreElements() == true */
    virtual T getNextElement() = 0;
};

#endif
